<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESObject Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1application_utilities.html">applicationUtilities</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1application_utilities_1_1android_utilities.html">androidUtilities</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESObject Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_android_s_l_e_s_object_8h_source.html">AndroidSLESObject.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ab51c6a1d7536c7cd1d82da499ffe0813"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html#ab51c6a1d7536c7cd1d82da499ffe0813">~AndroidSLESObject</a> ()</td></tr>
<tr class="separator:ab51c6a1d7536c7cd1d82da499ffe0813"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8561da1062c3db28b5012f13b9121a45"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html#a8561da1062c3db28b5012f13b9121a45">getInterface</a> (SLInterfaceID interfaceID, void *retObject)</td></tr>
<tr class="separator:a8561da1062c3db28b5012f13b9121a45"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a597a470d2426e2fefdc36c0a11fa3284"><td class="memItemLeft" align="right" valign="top">SLObjectItf&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html#a597a470d2426e2fefdc36c0a11fa3284">get</a> () const</td></tr>
<tr class="separator:a597a470d2426e2fefdc36c0a11fa3284"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:a6e913521480ad949693fc19498589f16"><td class="memItemLeft" align="right" valign="top">static std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a> &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html#a6e913521480ad949693fc19498589f16">create</a> (SLObjectItf slObject)</td></tr>
<tr class="separator:a6e913521480ad949693fc19498589f16"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">This class will represent an OpenSL ES object.</p>
<p class="">This class will abstract the object states as well as interface relationship from Open SL to be more C++ friendly. For more details see <a href="https://www.khronos.org/registry/OpenSL-ES/specs/OpenSL_ES_Specification_1.0.1.pdf">https://www.khronos.org/registry/OpenSL-ES/specs/OpenSL_ES_Specification_1.0.1.pdf</a> </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="ab51c6a1d7536c7cd1d82da499ffe0813"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab51c6a1d7536c7cd1d82da499ffe0813">&#9670;&nbsp;</a></span>~AndroidSLESObject()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESObject::~AndroidSLESObject </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class=""><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a> destructor. It will be responsible for destroying the underlying <code>SLObjectItf</code>. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a6e913521480ad949693fc19498589f16"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6e913521480ad949693fc19498589f16">&#9670;&nbsp;</a></span>create()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::unique_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a> &gt; alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESObject::create </td>
          <td>(</td>
          <td class="paramtype">SLObjectItf&#160;</td>
          <td class="paramname"><em>slObject</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">This method will create an <code><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a></code> and perform a synchronous realization.</p>
<p class="">At the end of this method, the internal <code>SLObjectItf</code> will be ready to be used.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">slObject</td><td>The C object that the new instance will wrap and own. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>A unique_ptr with a valid <code><a class="el" href="classalexa_client_s_d_k_1_1application_utilities_1_1android_utilities_1_1_android_s_l_e_s_object.html">AndroidSLESObject</a></code> if creation was successful, <code>nullptr</code> otherwise. </dd></dl>

</div>
</div>
<a id="a597a470d2426e2fefdc36c0a11fa3284"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a597a470d2426e2fefdc36c0a11fa3284">&#9670;&nbsp;</a></span>get()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">SLObjectItf alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESObject::get </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Get a raw pointer to the internal C object.</p>
<dl class="section return"><dt>Returns</dt><dd>A pointer to the internal C object. </dd></dl>
<dl class="section warning"><dt>Warning</dt><dd>Avoid storing the SLObjectItf since the parent OpenSLObject owns the underlying object. </dd></dl>

</div>
</div>
<a id="a8561da1062c3db28b5012f13b9121a45"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8561da1062c3db28b5012f13b9121a45">&#9670;&nbsp;</a></span>getInterface()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::applicationUtilities::androidUtilities::AndroidSLESObject::getInterface </td>
          <td>(</td>
          <td class="paramtype">SLInterfaceID&#160;</td>
          <td class="paramname"><em>interfaceID</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>retObject</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Get the object C interface.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir"></td><td class="paramname">interfaceID</td><td>The object C interface ID. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">retObject</td><td>The returned object. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>true if it succeeds and false if it fails. </dd></dl>
<dl class="section warning"><dt>Warning</dt><dd>The object interface is actually a pointer to the OpenSLObject internal object. Make sure that its lifecycle is not longer than the parent OpenSLObject. </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/ApplicationUtilities/AndroidUtilities/include/AndroidUtilities/<a class="el" href="_android_s_l_e_s_object_8h_source.html">AndroidSLESObject.h</a></li>
<li>/workplace/avs-device-sdk/ApplicationUtilities/AndroidUtilities/src/<a class="el" href="_android_s_l_e_s_object_8cpp.html">AndroidSLESObject.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
